// ---------------------------------------------------------------------------
//		 AVF 1.1 - Asynchronous Video Framework
//       
//       Philippe Lang, 1733 Treyvaux, SWITZERLAND
//       plang@com.mcnet.ch
// ---------------------------------------------------------------------------

#pragma once

#include "VideoSession.h"
#include "OffscreenWorld.h"
#include "OffscreenGroup.h"

enum AsyncBufferErr { NoOffWorld, NewHandleErr, HLockErr, VDGetDigitizerRectErr, VDPreflightDestinationErr, HUnlockErr, VDSetupBuffersErr, VDSetPlayThruDestinationErr, VDReleaseAsyncBuffersErr };

class AsyncBuffer {
public:
	AsyncBuffer( VideoSession* inSessionP, OffscreenGroup* inOffGroupP ) throw ( AsyncBufferErr );
	~AsyncBuffer() throw ( AsyncBufferErr );
	
protected:
	VdigBufferRecListHandle		mBufferListH;
	VideoDigitizerComponent		mVdigComp;
};