/*** File: ASSERT - V4.51
 *
 *	Define the new Assert library functions.
 *
 *	21/08/1996		minutes canges. (v451)
 *					Makes the assert file once incluseable.
 *					Now assert_warning, _assert_error, checkCondition
 *					use only two parameter (assert_warning .eq. assure)
 *						messageError = "%s%s%s%s" or "%s%s%s<message string>".
 *	24/02/1996		1st version (v45)
 *					Now _error display the error with a dialog if
 *						_error("%p%p%p%p", "\p", "\p", "\p", "\p");
 *					New _checkCondition function.
 ***/
#ifndef __ASSERT__
#define __ASSERT__
#include <assert.h>												//	Include the standard assert
#include <Types.h>
extern void _error(Boolean forceQuit, char * message, ... );	//	Print a message and abort
																//	if abort is true

#define assure(expr,message) 			\
	if	(expr) ;						\
	else _error(true, message)

#define assert_error(expr, message, err0, err1, err2, err3) 	\
	if	(expr) ;						\
		else _error(true, message, err0, err1, err2, err3)

#define assert_warning(expr, message, err0, err1, err2, err3) 	\
	if	(expr) ;						\
		else _error(false, message, err0, err1, err2, err3)	

#define checkCondition(expr, message, err0, err1, err2, err3)	\
		assert_error(expr, message, err0, err1, err2, err3)
#endif