/*** File: "checkUtilities_v00.c"
*
*	Versione 00. Del 24-10-94.
*	Scritto da Cadili Francesco.

*	Controlla il formato dei campi
*
******************************************/
#include <stdio.h>

/******** Dichiarazioni private ************************/
/******** Include locali *******************************/

#include "checkUtilities_v00.h"
#include "stringUtility_v02.h"

/******** Fine Include locali **************************/
/******** Strutture dati locali ************************/

/********* Fine Strutture dati locali *******************/
/******** Costanti locali ******************************/

#pragma segment checkUtilities
/******** Fine Costanti locali *************************/
/******** Funzioni private: ****************************/

/******** Fine Funzioni private ************************/
/******** Fine Dichiarazioni private ********************/

/*** result = checkForNum(txt, len, &num)
*
*	Controlla la presenza di un numero nello Handle.
*
*******************************************************/
Boolean checkForNum(Handle txt, short len, int *num)
{
	Handle cStrHdl;
	char *str;
	Boolean result = true;

	if (!copyHandletoCHandle(txt, len, &cStrHdl) || cStrHdl == NULL)
		return(false);
	
	HLock(cStrHdl);
	str = *cStrHdl;
	if (sscanf(str, "%i", num) != 1)
		result = false;
	HUnlock(cStrHdl);
	DisposHandle(cStrHdl);
	return(result);
}

/*** result = check(txt, len, &num)
*
*	Controlla la presenza di un ora nel campo
*
************************************************************************/
Boolean checkForHour(Handle txt, short len, int *ora, int *minuti)
{
	Handle cStrHdl;
	char *str;
	Boolean result = true;

	if (!copyHandletoCHandle(txt, len, &cStrHdl) || cStrHdl == NULL)
		return(false);
	
	HLock(cStrHdl);
	str = *cStrHdl;
	if (sscanf(str, "%i%*c%i", ora, minuti) != 2)
		result = false;
	HUnlock(cStrHdl);
	DisposHandle(cStrHdl);
	return(result);
}
