/*****
 *
 *	Grant's CGI Shell (Common Grant Interface :-)
 *		http://arpp.carleton.ca/cgi/framework/
 *
 *	MyListSTARProcess.c
 *
 *	Application framework for CGIs and ListSTAR events.
 *
 *	CustomListSTARProcess is where you will do your application specific processing
 *  of the ListSTAR event.
 *
 *	Modify this file.
 *
 *	by Grant Neufeld
 *
 *	Copyright 1995,1996 by Grant Neufeld
 *
 *	http://arpp.carleton.ca/cgi/framework/
 *	gneufeld@ccs.carleton.ca
 *	grant@acm.org
 *
 *	This source may be freely used as long as the copyright notice is kept in the source.
 *	I ask that you let me know of any enhancements (read: bug fixes) to this code.
 *	I would also like copies of (or discounts on) anything you produce using this code, please.
 *
 *****/

#include "MyConfiguration.h"
#if kCompileWithListSTARCode

#include <string.h>
#include <Threads.h>

#include "globals.h"

#include "ListSTAR.h"
#include "ProcessUtil.h"
		

/***  CUSTOM LISTSTAR EVENT FUNCTION  ***/

/* This function is where the ListSTAR event is actually processed.
	You should replace its contents with your own.
	(*theLStarHdl)->triggerValue should be positive if the event matches
		your trigger requirements, zero if it doesn't, and negative if an
		error occurred.
	
	(this function's prototype is defined in ListSTAR.h) */
void
CustomListSTARProcess ( LStarHdl theLStarHdl )
{
	/* This example doesn't really do anything.
		If used as a trigger, it always returns success */
	*((*theLStarHdl)->triggerValue) = Trigger_success;
	
	/* you should try to make use of giving time,
		especially in for and while loops or where you have to wait for
		some other process to return data or finish a task. */
	ProcessGiveTime ( nil, true, NULL );
} /* CustomListSTARProcess */


// this function has been removed
// use 'CustomStartup' in "MyHandlers.c" instead.
//
///***  CUSTOM LISTSTAR EVENT INITIALIZATION  ***/
//#pragma segment Startup
//
///* Put any of the initialization you need done, here.
//	This function will be called once: in-between the startup
//	sequence and the main event loop.
//	Return true if the initialization was successful, otherwise false.
//	An initialization failure will result in the application quitting. */
//Boolean
//MyListSTARStartup ( void )
//{
//	return true;
//} /* MyListSTARStartup */


#endif	/* kCompileWithListSTARCode */

/*** EOF ***/
