/*****
 *
 *	MenuFunc.c
 *
 *	This is a support file for "Grant's CGI Framework".
 *	Please see the license agreement that accompanies the distribution package
 *	for licensing details.
 *
 *	Copyright 1995,1996 by Grant Neufeld
 *	grant@acm.com
 *	http://arpp.carleton.ca/cgi/framework/
 *
 *****/

#include "MyConfiguration.h"
#if kCompileWithForeground

#include "globals.h"

#include "ErrorUtil.h"
#include "MenuApple.h"
#include "MenuFile.h"
#include "MenuEdit.h"
#include "MenuOptions.h"
#include "Quit.h"
#include "WindowInt.h"

#include "MenuFunc.h"


/***  FUNCTIONS  ***/

/* setup menus */
void
MenuStartup ( void )
{
	Handle	theMenuBar;
	
	theMenuBar = GetNewMBar ( kmMenuBarID );
	if ( theMenuBar == NULL )
	{
		/* can't load menu bar */
		ErrorStartup ( kerrStartupMenu );
	}
	
	SetMenuBar ( theMenuBar );

	gmAppleMenu	= GetMHandle ( kmAppleMenuID );
	/* add "Apple Menu Items" to the Apple menu */
	AddResMenu	( gmAppleMenu, 'DRVR' );

	gmFileMenu   = GetMHandle ( kmFileMenuID );
	gmEditMenu   = GetMHandle ( kmEditMenuID );
	#if kCompileWithMenuOptions
	gmOptionMenu = GetMHandle ( kmOptionMenuID );
	#endif
	
	DrawMenuBar ();
} /* MenuStartup */


#pragma mark -

/* Handle a menu selection */
void 
doMenu ( long menuResult, short modifiers  )
{
	short	menuID;
	short	itemNumber;
	
	/* determine which menu */
	menuID = HiWord ( menuResult );
	/* determine which menu item */
	itemNumber = LoWord ( menuResult );
	
	switch ( menuID ) 
	{
		case kmAppleMenuID :
			doAppleMenu ( itemNumber, modifiers );
			break;
			
		case kmFileMenuID :
			doFileMenu ( itemNumber, modifiers );
			break;
			
		case kmEditMenuID :
			doEditMenu ( itemNumber, modifiers );
			break;
		
		#if kCompileWithMenuOptions
		case kmOptionMenuID :
			doOptionMenu ( itemNumber, modifiers );
			break;
		#endif
	}
	
	HiliteMenu ( 0 );
	
	/* reset 'quit on idle time' timer */
	ResetQuitIdleTimer();
} /* doMenu */


/*  */
void
adjustMenus ( void )
{
	WindowPtr		theWindow;
	window_type		theWindowType;
	
	theWindow = FrontWindow ();
	theWindowType = WindowType ( theWindow );
	
	adjustAppleMenu		( theWindowType );
	adjustFileMenu		( theWindowType );
	adjustEditMenu		( theWindowType );
	#if kCompileWithMenuOptions
	adjustOptionMenu	( theWindowType );
	#endif
} /* MenusAdjust */


#endif	/* kCompileWithForeground */

/*****  EOF  *****/
