#pragma once
/*****
 *
 *	MenuFunc.h
 *
 *	This is a support file for "Grant's CGI Framework".
 *	Please see the license agreement that accompanies the distribution package
 *	for licensing details.
 *
 *	Copyright 1995,1996 by Grant Neufeld
 *	grant@acm.com
 *	http://arpp.carleton.ca/cgi/framework/
 *
 *****/

#include "MyConfiguration.h"
#if kCompileWithForeground

/***  CONSTANT DECLARATIONS  ***/

#define kmMenuBarID			128		/* resource ID of the main application menubar */
#define kmDefaultMenuStr	299
#define kmTheWholeMenu		0
#define kmAfterOtherMenus	0
#define kmSubMenu			-1

#define	kmAppleMenuID		128
#define	kmFileMenuID		129
#define	kmEditMenuID		130
#define	kmOptionMenuID		131


/***  GLOBAL DECLARATIONS  ***/

#ifdef __MainSegment__
	#ifdef _GLOBAL_
		#undef _GLOBAL_
	#endif
	#define	_GLOBAL_
#else
	#ifdef _GLOBAL_
		#undef _GLOBAL_
	#endif
	#define	_GLOBAL_	extern
#endif


_GLOBAL_	MenuHandle 	gmAppleMenu;
_GLOBAL_	MenuHandle	gmFileMenu;
_GLOBAL_	MenuHandle	gmEditMenu;
#if kCompileWithMenuOptions
_GLOBAL_	MenuHandle	gmOptionMenu;
#endif

#ifdef _GLOBAL_
#undef _GLOBAL_
#endif


/***  FUNCTION PROTOTYPES  ***/

	void	MenuStartup	( void );
	
	void	adjustMenus	( void );
	void	doMenu		( long, short );	/* menuResult, modifiers */


#else	/* if not kCompileWithForeground */

	/* no interface, so define the menu functions to be nothing */
	#define MenuStartup()	
	#define adjustMenus()	
	#define doMenu(a,b)	

#endif	/* kCompileWithForeground */

/***** EOF *****/
