/*****
 *
 *	MenuOptions.c
 *
 *	This is a support file for "Grant's CGI Framework".
 *	Please see the license agreement that accompanies the distribution package
 *	for licensing details.
 *
 *	Copyright 1996 by Grant Neufeld
 *	grant@acm.com
 *	http://arpp.carleton.ca/cgi/framework/
 *
 *****/

#include "MyConfiguration.h"
#if kCompileWithForeground && kCompileWithMenuOptions

#include "globals.h"

#include "MenuFunc.h"
#include "PrefDialog.h"
#include "PrefUtil.h"
//#include "Quit.h"
//#include "WindowInt.h"

#include "MenuOptions.h"


/***  FUNCTIONS  ***/

/*  */
void
doOptionMenu ( short theItem, short modifiers )
{
#pragma unused(modifiers)
	switch ( theItem ) 
	{
		case kmiQuitOnIdle :
			PrefSaveDoIdleQuit ( !gDoIdleQuit );
			gDoIdleQuit = !gDoIdleQuit;
			break;
		
#if 0
		case kmiSaveCurrentSettings :
			PrefSaveCurrentSettings ();
			break;
#endif
		
		case kmiPreferences :
			PrefDialog ();
			break;
		
		default :
			/* invalid item */
			break;
	}
	
} /* doOptionMenu */


/*  */
void
adjustOptionMenu ( window_type theWindowType )
{
	#if kCompileWithQuitOnLongIdle
	if ( gDoIdleQuit )
	{
		/* mark the menu to indicate that Quit On Idle is active */
		SetItemMark ( gmOptionMenu, kmiQuitOnIdle, checkMark );
	}
	else
	{
		SetItemMark ( gmOptionMenu, kmiQuitOnIdle, noMark );
	}
	#endif
	
	switch ( theWindowType )
	{
		case Window_dlgModal :
		case Window_dlgMoveableModal :
			DisableItem ( gmOptionMenu, kmiQuitOnIdle );
#if 0
			DisableItem ( gmOptionMenu, kmiSaveCurrentSettings );
#endif
			DisableItem ( gmOptionMenu, kmiPreferences );
			break;
		
		case Window_about :
		case Window_DA :
		case Window_Application :
		case Window_none :
		case Window_UNKNOWN :
		default :
			#if kCompileWithQuitOnLongIdle
			EnableItem ( gmOptionMenu, kmiQuitOnIdle );
			#else
			DisableItem ( gmOptionMenu, kmiQuitOnIdle );
			#endif
#if 0
			EnableItem ( gmOptionMenu, kmiSaveCurrentSettings );
#endif
			EnableItem ( gmOptionMenu, kmiPreferences );
			break;
	}
	
	EnableItem ( gmOptionMenu, kmTheWholeMenu );
} /* adjustOptionMenu */


#endif	/* kCompileWithForeground && kCompileWithMenuOptions */

/*****  EOF  *****/
