#pragma once
/*****
 *
 *	WindowInt.h
 *
 *	This is a support file for "Grant's CGI Framework".
 *	Please see the license agreement that accompanies the distribution package
 *	for licensing details.
 *
 *	Copyright 1995,1996 by Grant Neufeld
 *	grant@acm.com
 *	http://arpp.carleton.ca/cgi/framework/
 *
 *****/

#include "MyConfiguration.h"
#if kCompileWithForeground

/***  CONSTANT DECLARATIONS  ***/

#define kMinWindSize	48


/***  TYPE DECLARATIONS  ***/

typedef enum
{
	Window_UNKNOWN,				/* unrecognized type of window */
	
	Window_none,				/* not a window */
	Window_dlgModal,			/* modal dialog */
	Window_dlgMoveableModal,	/* moveable modal dialog */
	Window_dlgModeless,			/* modeless dialog */
	Window_about,				/* about box */
	Window_DA,					/* desk accessory window */
	
	Window_Application			/* custom application window */
} window_type;
	
typedef struct
{
	window_type		wType;
	Boolean			scrollbars;
	long			data;
} windowInfo;

typedef windowInfo** windowInfoHdl;


/***  FUNCTION PROTOTYPES  ***/

	void			WindowMenuClose		( short );
	
	void			WindowActivate		( WindowPtr, Boolean, const EventRecord * );
	void			WindowUpdate		( WindowPtr );
	void 			WindowContentClick	( WindowPtr, const EventRecord *, Boolean * );
	void			WindowZoomBox		( WindowPtr, short );
	void 			WindowGrow			( WindowPtr, Point );
	void 			WindowGrowHandler	( WindowPtr, Point );
	
	Boolean			WindowClose			( WindowPtr, short, Boolean );
	Boolean			WindowCloseAll		( Boolean );
	
	window_type		WindowType			( WindowPtr );
	
	Boolean			WindowNewSetInfo	( WindowPtr, window_type, Boolean, long );
	windowInfoHdl	WindowNewInfoHdl	( window_type, Boolean, long );
	void			WindowSetInfoHdl	( WindowPtr, windowInfoHdl );
	windowInfoHdl	WindowGetInfoHdl	( WindowPtr );
	void			WindowDisposeInfoHdl	( WindowPtr );
	long			WindowGetData		( WindowPtr );
	/* for backwards compatibility. Avoid use */
	Handle			WindowGetDataHdl	( WindowPtr );
	

#endif	/* kCompileWithForeground */

/***** EOF *****/
