#pragma once
/*****
 *
 *	PrefUtil.h
 *
 *	This is a support file for "Grant's CGI Framework".
 *	Please see the license agreement that accompanies the distribution package
 *	for licensing details.
 *
 *	Copyright 1996 by Grant Neufeld
 *	grant@acm.com
 *	http://arpp.carleton.ca/cgi/framework/
 *
 *****/

#if kCompileWithPreferences

#include "CGI.h"

/***  CONSTANT DECLARATIONS  ***/

#define kPrefResType				'Pref'

#define krPrefSleepTicks			501
#define krPrefSleepTicksBusy		502
#define krPrefDoIdleQuit			505
#define krPrefDoIdleQuitOnOpenApp	506
#define krPrefIdleTimeToQuit		507

//#define krPrefStartupThreads		0
//#define krPrefQuitOnIdle			2
//#define krPrefIdleTimeBeforeQuit	4


/***  TYPE DECLARATIONS  ***/

/***  GLOBAL DECLARATIONS  ***/

#ifdef __MainSegment__
#define _GLOBAL_	
#else
#define _GLOBAL_	extern
#endif

_GLOBAL_	short		gPrefStartupThreads;
_GLOBAL_	Boolean		gPrefQuitOnIdle;
_GLOBAL_	long		gPrefIdleTimeBeforeQuit;

#undef _GLOBAL_


/***  FUNCTION PROTOTYPES  ***/

	void	PrefStartup		( void );
	
p_export Handle	PrefItemGet		( short, ResType );
p_export void	PrefItemRelease	( Handle );
p_export OSErr	PrefItemSave	( short, ResType, void *, short, StringPtr );
p_export OSErr	PrefItemCGISave ( CGIHdl, short, ResType, void *, short, StringPtr );

#if 0
	void	PrefSaveCurrentSettings		( void );
#endif

	void	PrefSaveSleepTicks			( UInt32 );
	void	PrefSaveSleepTicksBusy		( UInt32 );
	void	PrefSaveDoIdleQuit			( SInt16 );
	void	PrefSaveDoIdleQuitOnOpenApp	( SInt16 );
	void	PrefSaveIdleTimeToQuit		( UInt32 );


#else

#define PrefStartup()	
#define PrefItemGet(a,b)				(NULL)
#define PrefItemRelease(a)	
#define PrefItemSave(a,b,c,d,e)			(noErr)
#define PrefItemCGISave(a,b,c,d,e,f)	(noErr)
#define PrefSaveSleepTicks(a)	
#define PrefSaveSleepTicksBusy(a)	
#define PrefSaveDoIdleQuit(a)	
#define PrefSaveDoIdleQuitOnOpenApp(a)	
#define PrefSaveIdleTimeToQuit(a)	

#endif /* kCompileWithPreferences */
/*****  EOF  *****/
