#pragma once
/*****
 *
 *	ProcessUtil.h
 *
 *	This is a support file for "Grant's CGI Framework".
 *	Please see the license agreement that accompanies the distribution package
 *	for licensing details.
 *
 *	Copyright 1995,1996 by Grant Neufeld
 *	grant@acm.org  grant@kagi.com
 *	http://arpp.carleton.ca/cgi/framework/
 *
 *****/

#include "MyConfiguration.h"

#include <Threads.h>
#if kCompilingForWSAPI
#include <WSAPI.h>
#endif

#include "CGI.h"


/***  CONSTANTS  ***/

#define kProcessNoTimeout	nil


/***  FUNCTION PROTOTYPES  ***/

	void		ProcessStartup			( void );
	
p_export void	ProcessGiveTime			( UInt32, Boolean, CGIHdl );
	
	Boolean		ProcessCurrentIsFront	( void );
	Boolean		ProcessWaitUntilFront	( unsigned long );
	Boolean		ProcessIsFront			( ProcessSerialNumber * );
	OSErr		ProcessGetMyFSSpec		( FSSpec * );
	
p_export void	ProcessIsMoreBusy		( void );
p_export void	ProcessIsLessBusy		( void );

		void	ProcessResetSleep		( void );
p_export void	ProcessSleepSetDefault	( UInt32 );
p_export void	ProcessSleepSetBusy		( UInt32 );
p_export UInt32	ProcessSleepGetDefault	( void );
p_export UInt32	ProcessSleepGetBusy		( void );
p_export void	ProcessSleepDefault		( void );
p_export void	ProcessSleepBusy		( void );
	
#if kCompileWithPeriodicTask
		void	ProcessPeriodicTask		( 
					#if kCompilingForWSAPI
					WSAPI_CommandPBPtr commandPtr
					#else
					void
					#endif
					);
#endif
	
		 void	ThreadStartup			( void );
p_export OSErr	ThreadYield				( ThreadID, Boolean );

#if kStartupThreadsPreallocate > 0
p_export OSErr	ThreadNewThreadFromPool	( ThreadEntryProcPtr, void *, void **, ThreadID * );
		 void	ThreadFinishAllSubThreads	( void );

p_export OSErr	ThreadSleep				( ThreadID );
p_export OSErr	ThreadWakeNext			( void );
		 void	ThreadWakeAll			( void );
#endif

#define ProcessIsBackgroundOnly		(!(kCompileWithForeground))


#if !(kCompileWithout_MY_Names)
#define MyNewThreadFromPool	ThreadNewThreadFromPool
#endif


/***** EOF *****/
